/**************************************************************************************************
  Filename:       serialDataTransfer_util.h
  Revised:        $Date: 2014-07-01 10:24:16 -0100 (Tue, 01 Jul 2014) $
  Revision:       $Revision: 1 $

  Description:    This file contains the Simple BLE Peripheral sample application
                  definitions and prototypes.

  Copyright 2010 - 2011 Texas Instruments Incorporated. All rights reserved.

  IMPORTANT: Your use of this Software is limited to those specific rights
  granted under the terms of a software license agreement between the user
  who downloaded the software, his/her employer (which must be your employer)
  and Texas Instruments Incorporated (the "License").  You may not use this
  Software unless you agree to abide by the terms of the License. The License
  limits your use, and you acknowledge, that the Software may not be modified,
  copied or distributed unless embedded on a Texas Instruments microcontroller
  or used solely and exclusively in conjunction with a Texas Instruments radio
  frequency transceiver, which is integrated into your product.  Other than for
  the foregoing purpose, you may not use, reproduce, copy, prepare derivative
  works of, modify, distribute, perform, display or sell this Software and/or
  its documentation for any purpose.

  YOU FURTHER ACKNOWLEDGE AND AGREE THAT THE SOFTWARE AND DOCUMENTATION ARE
  PROVIDED AS IS WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED,
  INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY, TITLE,
  NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL
  TEXAS INSTRUMENTS OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER CONTRACT,
  NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR OTHER
  LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
  INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE
  OR CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT
  OF SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
  (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.

  Should you have any questions regarding your right to use this Software,
  contact Texas Instruments Incorporated at www.TI.com.
**************************************************************************************************/

#ifndef SERIALDATATRANSFER_UTIL_H
#define SERIALDATATRANSFER_UTIL_H

#ifdef __cplusplus
extern "C"
{
#endif

#define EVEN                            TRUE
#define ODD                             FALSE 
  
#ifndef CHARACTERISTIC_LEN
#define CHARACTERISTIC_LEN              ATT_MTU_SIZE-3
#endif
  
// UART configurations  
#define SDT_UART_PORT                  HAL_UART_PORT_0
#define SDT_UART_FC                    FALSE
#define SDT_UART_FC_THRESHOLD          48
#define SDT_UART_RX_BUF_SIZE           256
#define SDT_UART_TX_BUF_SIZE           256
#define SDT_UART_IDLE_TIMEOUT          6
#define SDT_UART_INT_ENABLE            TRUE
 
// UART baud rate and parity
#define SDT_UART_BR                     HAL_UART_BR_19200
#define MODBUS_USE_PARITY               TRUE
#define MODBUS_PARITY                   EVEN 
  
// Modbus timing demands (experimental values)
#if SDT_UART_BR == HAL_UART_BR_9600
  #define MODBUS_RX_TIMEOUT       0x2000
  
#elif SDT_UART_BR == HAL_UART_BR_19200
  #define MODBUS_RX_TIMEOUT       0x1000
  
#elif SDT_UART_BR == HAL_UART_BR_38400
  #define MODBUS_RX_TIMEOUT       0x0650
  
#elif SDT_UART_BR == HAL_UART_BR_57600
  #define MODBUS_RX_TIMEOUT       0x0450
  
#else //SDT_UART_BR == HAL_UART_115200
  #define MODBUS_RX_TIMEOUT       0x0228
#endif
  
#define SET_DE()                        U0CSR &= ~0x40; P0 |= 0x10//P0 |= 0x30      //set pin 4 and 5, disable rx on the uart
#define CLEAR_DE()                      U0UCR |= 0x80; U0CSR |= 0x40; P0 &= ~0x10       //P0 &= ~0x30     //clear pin 4 and 5, flush and re-enable uart rx
 
  
extern void Modbus_initUART();
extern void Modbus_initTimer();

extern uint8 Modbus_WriteSerial(uint8 uartPort, uint8* data, uint16 length);
extern void Modbus_GetFragment(uint8 *data, uint8 length);

extern void RS485_InitBoard(uint8 taskId);

extern void RS485_enableTest();


  
#ifdef __cplusplus
}
#endif
  
#endif //SERIALDATATRANSFER_UTIL_H
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
 
 